
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import entity.Student;

public class ConnectMySQL {
	
	
	
	static List<Student> getAllStudenst(){
		String URL = "jdbc:mysql://localhost:3306/teststu?serverTimezone=Asia/Chongqing&useUnicode=true";
        String driverName = "com.mysql.cj.jdbc.Driver";//My SQL 6
        String sql = "select * from students";
        String userName = "root";// root
        String password = "123456";// 123456
        Connection conn = null;
        Statement statement = null;
        ResultSet resultSet = null;
        
        List<Student> stuList = new ArrayList<>();
        
        try {
            Class.forName(driverName);// Class.forName(driverName);//jdbc4.0 ʹøע
            
            conn = DriverManager.getConnection(URL, userName, password);
            statement = conn.createStatement();
            resultSet = statement.executeQuery(sql);
            // id | stuno | name | gender | birthdate | major
            
            while (resultSet.next()) {
            	Student s = new Student();
                long id = resultSet.getLong("id");
                String stuno = resultSet.getString("stuno");
                //LocalDate date = (LocalDate)resultSet.getObject("birthdate");
                LocalDate date = resultSet.getObject("birthdate", LocalDate.class);
                s.setId(id);
                s.setStuno(stuno);
                s.setBirthdate(date);
                stuList.add(s);
            }

        } catch (SQLException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } finally {/*ʹtry..with..resourcesɼԴͷ*/
            if (resultSet != null) {
                try {
                    resultSet.close();
					resultSet = null;
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
            if (statement != null) {
                try {
                    statement.close();
                    statement = null;
                } catch (SQLException e) {
                    e.printStackTrace();
                }

            }
            if (conn != null)
                try {
                    conn.close();
                    conn = null;
                } catch (SQLException e) {
                    e.printStackTrace();
                } 

        }
		return stuList;
	}

    public static void main(String[] args) {
    	List<Student> allStudenst = getAllStudenst();
    	for (Student student : allStudenst) {
			System.out.println(student);
		}
    }
}
