package db1;

import java.sql.Connection;
import java.sql.Date;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import model.Student;
import utils.JDBCUtil;

//ʹJDBCUtilĴ
public class ConnectMySQLBetter {

	public static void main(String[] args) {
		
		Date date = new Date(System.currentTimeMillis());//ȡǰ
		Student s = new Student("a", "2001111", "", 100, date, "net");
		
		insert(s);
		List<Student> stuList = getAllStudents();
		for (Student e : stuList) {
			System.out.println(e);
		}
	}

	private static List<Student> getAllStudents() {
		// JDBCһЩ
		String sql = "select * from student";
		Connection conn = null;
		Statement statement = null;
		ResultSet resultSet = null;

		List<Student> stuList = new ArrayList<>();
		try {
			conn = JDBCUtil.getConnection();
			statement = conn.createStatement();
			resultSet = statement.executeQuery(sql);
			// id | stuno | name | gender | birthdate | major
			while (resultSet.next()) {
				int id = resultSet.getInt("id");
				String stuno = resultSet.getString("stuno");
				Date date = resultSet.getDate("birthdate");
				Student s = new Student();
				s.setId(id);
				s.setStuno(stuno);
				s.setBirthdate(date);
				stuList.add(s);
				System.out.println("id=" + id + " stuno=" + stuno + " birthdate=" + date);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {/* Դͷţʹtry..with..resources﷨ */
			JDBCUtil.realeaseAll(resultSet, statement, conn);
		}
		return stuList;

	}

	//ʹString.format˷ϸʽSQL䣬һ˵ӦʹPreparedStatementвѯ
	//죺ʹPreparedStatement·
	public static int insert(Student stu) {
		
		String sqlx = "insert into students(stuno,name,age,gender,birthdate) " + "values('%s', '%s', %d, '%s','%s');";
		String sql = String.format(sqlx, stu.getStuno(), stu.getName(), stu.getAge(), stu.getGender(),
				stu.getBirthdate());
		Connection conn = null;
		Statement statement = null;
		ResultSet resultSet = null;
		int num = -1;
		try {
			conn = JDBCUtil.getConnection();
			statement = conn.createStatement();
			num = statement.executeUpdate(sql);
			System.out.println("Ѳ" + num + "");

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			JDBCUtil.realeaseAll(resultSet, statement, conn);
		}

		return num;

	}

}
