package model;

import java.time.LocalDate;

public class Student {
	private Long id;
	private String stuno;
	private String name;
	private String gender;
	private Integer age;
	private LocalDate birthdate;
	private String major;

	
	public Student() {
		
	}

	public Student(String name, String stuno, String gender, Integer age, LocalDate birthdate, String major) {
		this.name = name;
		this.stuno = stuno;
		this.gender = gender;
		this.age = age;
		this.birthdate = birthdate;
		this.major = major;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getStuno() {
		return stuno;
	}

	public void setStuno(String stuno) {
		this.stuno = stuno;
	}

	public String getGender() {
		return gender;
	}

	public void setGender(String gender) {
		this.gender = gender;
	}

	public Integer getAge() {
		return age;
	}

	public void setAge(Integer age) {
		this.age = age;
	}

	public LocalDate getBirthdate() {
		return birthdate;
	}

	public void setBirthdate(LocalDate birthdate) {
		this.birthdate = birthdate;
	}

	public String getMajor() {
		return major;
	}

	public void setMajor(String major) {
		this.major = major;
	}

	@Override
	public String toString() {
		return "Student [id=" + id + ", stuno=" + stuno + ", name=" + name + ", gender=" + gender + ", age=" + age
				+ ", birthdate=" + birthdate + ", major=" + major + "]";
	}
	
}
